CSIT-1282 Migrate from Nexus.fd.io to packagecloud.io
[csit.git] / bootstrap-vpp-verify-semiweekly.sh
1 #!/bin/bash
2 # Copyright (c) 2016 Cisco and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a ght (c) 2016 Cisco and/or its affiliates.
6 # Licensed under the Apache License, Version 2.0 (the "License");
7 # you may not usecopy of the License at:
8 #
9 #     http://www.apache.org/licenses/LICENSE-2.0
10 #
11 # Unless required by applicable law or agreed to in writing, software
12 # distributed under the License is distributed on an "AS IS" BASIS,
13 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14 # See the License for the specific language governing permissions and
15 # limitations under the License.
16
17 set -x
18
19 RETURN_STATUS=0
20
21 cat /etc/hostname
22 cat /etc/hosts
23
24 PYBOT_ARGS="--noncritical MULTI_THREAD"
25
26 JOB_ARCHIVE_ARTIFACTS=(log.html output.xml report.html)
27 LOG_ARCHIVE_ARTIFACTS=(log.html output.xml report.html)
28 JOB_ARCHIVE_DIR="archive"
29 LOG_ARCHIVE_DIR="$WORKSPACE/archives"
30 mkdir -p ${JOB_ARCHIVE_DIR}
31 mkdir -p ${LOG_ARCHIVE_DIR}
32
33 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
34 export PYTHONPATH=${SCRIPT_DIR}
35
36 # Create tmp dir
37 mkdir ${SCRIPT_DIR}/tmp
38
39 # Use tmp dir to store log files
40 LOG_PATH="${SCRIPT_DIR}/tmp"
41
42 OS_ID=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g')
43 OS_VERSION_ID=$(grep '^VERSION_ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g')
44
45 if [ "$OS_ID" == "centos" ]; then
46     DISTRO="CENTOS"
47     PACKAGE="rpm"
48     sudo yum install -y python-devel python-virtualenv
49 elif [ "$OS_ID" == "ubuntu" ]; then
50     DISTRO="UBUNTU"
51     PACKAGE="deb"
52     export DEBIAN_FRONTEND=noninteractive
53     sudo apt-get -y update
54     sudo apt-get -y install libpython2.7-dev python-virtualenv
55 else
56     echo "$OS_ID is not yet supported."
57     exit 1
58 fi
59
60 # 1st step: Download and prepare VPP packages
61
62 # Temporarily download VPP packages from nexus.fd.io
63 if [ "${#}" -ne "0" ]; then
64     arr=(${@})
65     echo ${arr[0]}
66 else
67     # Download the latest VPP build install packages
68     source "${SCRIPT_DIR}/resources/libraries/bash/function/artifacts.sh"
69     download_artifacts
70     # Need to revert -euo as the rest of script is not optimized for this.
71     set +euo pipefail
72 fi
73
74 VIRL_DIR_LOC="/tmp/"
75 VPP_PKGS=(vpp*.$PACKAGE)
76 VPP_PKGS_FULL=("${VPP_PKGS[@]/#/${VIRL_DIR_LOC}}")
77 echo ${VPP_PKGS[@]}
78
79 VIRL_TOPOLOGY=$(cat ${SCRIPT_DIR}/VIRL_TOPOLOGY_${DISTRO})
80 VIRL_RELEASE=$(cat ${SCRIPT_DIR}/VIRL_RELEASE_${DISTRO})
81
82 VPP_VER="$( expr match $(ls vpp*.${PACKAGE} | head -n 1) 'vpp[-|_]\(.*\)'.${PACKAGE} )"
83
84 set +x
85 echo "****************************************************************************************************************************************"
86 echo "1st step: Download VPP packages                                                                                                 FINISHED"
87 echo "VPP version to be tested: ${VPP_VER}"
88 echo "****************************************************************************************************************************************"
89 set -x
90
91
92 # 2nd step: Start virtual env and install requirements
93
94 echo Starting virtual env...
95 virtualenv --system-site-packages env
96 . env/bin/activate
97
98 echo Installing requirements...
99 pip install -r ${SCRIPT_DIR}/requirements.txt
100
101 set +x
102 echo "****************************************************************************************************************************************"
103 echo "2nd step: Start virtual env and install requirements                                                                            FINISHED"
104 echo "****************************************************************************************************************************************"
105 set -x
106
107
108 # 3rd step: Prepare VIRL system
109 echo Preparing VIRL system...
110
111 VIRL_SERVERS=("10.30.51.28" "10.30.51.29" "10.30.51.30")
112 VIRL_SERVER=""
113
114 VIRL_USERNAME=jenkins-in
115 VIRL_PKEY=priv_key
116 VIRL_SERVER_STATUS_FILE="status"
117 VIRL_SERVER_EXPECTED_STATUS="PRODUCTION"
118 VIRL_SESSION_EXPIRY="620"
119
120 SSH_OPTIONS="-i ${VIRL_PKEY} -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null -o BatchMode=yes -o LogLevel=error"
121
122 function ssh_do() {
123     echo
124     echo "### "  ssh $@
125     ssh ${SSH_OPTIONS} $@
126 }
127
128 rm -f ${VIRL_PKEY}
129 cat > ${VIRL_PKEY} <<EOF
130 -----BEGIN RSA PRIVATE KEY-----
131 MIIEpQIBAAKCAQEA+IHXq87GcqMR1C47rzx6Cbip5Ghq8pKrbqKrP5Nf41HcYrT6
132 GOXl9nFWKsMOzIlIn+8y7Il27eZh7csQGApbg8QLiHMtcYEmWNzKZpkqg4nuAPxX
133 VXwlKgnKX902SrET9Gp9TDayiHtCRWVfrlPPPSA0UEXW6BjLN/uHJ+W/Xzrrab+9
134 asBVa05vT2W6n0KJ66zfCaeDM912mQ6SttscAwFoWDmdHlegiVqrlIG2ABxOvxxz
135 L3dM3iSmlmQlzv9bThjo+nI4KFYh6m5wrZmAo5r/4q9CIJc21HVnTqkGOWJIZz6J
136 73lePJVSq5gYqaoGw3swFEA/MDkOx7baWKSoLQIDAQABAoIBAQCNBeolNp+JWJ76
137 gQ4fwLsknyXSV6sxYyhkDW4PEwwcTU06uqce0AAzXVffxne0fMe48x47+zqBgPbb
138 4huM+Pu8B9nfojUMr5TaYtl9Zbgpk3F8H7dT7LKOa6XrxvZTZrADSRc30+Z26zPN
139 e9zTaf42Gvt0/l0Zs1BHwbaOXqO+XuwJ3/F9Sf3PQYWXD3EOWjpHDP/X/1vAs6lV
140 SLkm6J/9KKE1m6I6LTYjIXuYt4SXybW6N2TSy54hhQtYcDUnIU2hR/PHVWKrGA0J
141 kELgrtTNTdbML27O5gFWU4PLUEYTZ9fN11D6qUZKxLcPOiPPHXkiILMRCCnG5DYI
142 ksBAU/YlAoGBAPxZO9VO18TYc8THV1nLKcvT2+1oSs1UcA2wNQMU55t910ZYinRa
143 MRwUhMOf8Mv5wOeiZaRICQB1PnVWtDVmGECgPpK6jUxqAwn8rgJcnoafLGL5YKMY
144 RVafTe6N5LXgCaOcJrk21wxs6v7ninEbUxxc575urOvZMBkymDw91dwbAoGBAPwa
145 YRhKhrzFKZzdK0RadVjnxKvolUllpoqqg3XuvmeAJHAOAnaOgVWq68NAcp5FZJv0
146 2D2Up7TX8pjf9MofP1SJbcraKBpK4NzfNkA0dSdEi+FhVofAJ9umB2o5LW1n7sab
147 UIrjsdzSJK/9Zb9yTTHPyibYzNEgaJV1HsbxfEFXAoGAYO2RmvRm0phll18OQVJV
148 IpKk9kLKAKZ/R/K32hAsikBC8SVPQTPniyaifFWx81diblalff2hX4ipTf7Yx24I
149 wMIMZuW7Im/R7QMef4+94G3Bad7p7JuE/qnAEHJ2OBnu+eYfxaK35XDsrq6XMazS
150 NqHE7hOq3giVfgg+C12hCKMCgYEAtu9dbYcG5owbehxzfRI2/OCRsjz/t1bv1seM
151 xVMND4XI6xb/apBWAZgZpIFrqrWoIBM3ptfsKipZe91ngBPUnL9s0Dolx452RVAj
152 yctHB8uRxWYgqDkjsxtzXf1HnZBBkBS8CUzYj+hdfuddoeKLaY3invXLCiV+PpXS
153 U4KAK9kCgYEAtSv0m5+Fg74BbAiFB6kCh11FYkW94YI6B/E2D/uVTD5dJhyEUFgZ
154 cWsudXjMki8734WSpMBqBp/J8wG3C9ZS6IpQD+U7UXA+roB7Qr+j4TqtWfM+87Rh
155 maOpG56uAyR0w5Z9BhwzA3VakibVk9KwDgZ29WtKFzuATLFnOtCS46E=
156 -----END RSA PRIVATE KEY-----
157 EOF
158 chmod 600 ${VIRL_PKEY}
159
160 #
161 # Pick a random host from the array of VIRL servers, and attempt
162 # to reach it and verify it's status.
163 #
164 # The server must be reachable, and have a "status" file with
165 # the content "PRODUCTION", to be selected.
166 #
167 # If the server is not reachable, or does not have the correct
168 # status, remove it from the array and start again.
169 #
170 # Abort if there are no more servers left in the array.
171 #
172 while [[ ! "$VIRL_SERVER" ]]
173 do
174     num_hosts=${#VIRL_SERVERS[@]}
175     if [ $num_hosts == 0 ]
176     then
177         echo "No more VIRL candidate hosts available, failing."
178         exit 127
179     fi
180     element=$[ $RANDOM % $num_hosts ]
181     virl_server_candidate=${VIRL_SERVERS[$element]}
182     virl_server_status=$(ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${virl_server_candidate} cat $VIRL_SERVER_STATUS_FILE 2>&1)
183     echo VIRL HOST $virl_server_candidate status is \"$virl_server_status\"
184     if [ "$virl_server_status" == "$VIRL_SERVER_EXPECTED_STATUS" ]
185     then
186         # Candidate is in good status. Select this server.
187         VIRL_SERVER="$virl_server_candidate"
188     else
189         # Candidate is in bad status. Remove from array.
190         VIRL_SERVERS=("${VIRL_SERVERS[@]:0:$element}" "${VIRL_SERVERS[@]:$[$element+1]}")
191     fi
192 done
193
194 # Copy the files to VIRL host
195 scp ${SSH_OPTIONS} ${VPP_PKGS[@]} \
196     ${VIRL_USERNAME}@${VIRL_SERVER}:${VIRL_DIR_LOC}/
197
198 result=$?
199 if [ "${result}" -ne "0" ]; then
200     echo "Failed to copy vpp deb files to virl host"
201     echo ${result}
202     exit ${result}
203 fi
204
205 # Start a simulation on VIRL server
206 echo "Starting simulation on VIRL server"
207
208 function stop_virl_simulation {
209     ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${VIRL_SERVER}\
210         "stop-testcase ${VIRL_SID}"
211 }
212
213 VIRL_SID=$(ssh ${SSH_OPTIONS} \
214     ${VIRL_USERNAME}@${VIRL_SERVER} \
215     "start-testcase -vv --copy ${VIRL_TOPOLOGY} \
216     --expiry ${VIRL_SESSION_EXPIRY} \
217     --release ${VIRL_RELEASE} ${VPP_PKGS_FULL[@]}")
218 retval=$?
219 if [ ${retval} -ne "0" ]; then
220     echo "VIRL simulation start failed"
221     exit ${retval}
222 fi
223
224 if [[ ! "${VIRL_SID}" =~ session-[a-zA-Z0-9_]{6} ]]; then
225     echo "No VIRL session ID reported."
226     exit 127
227 fi
228
229 # Upon script exit, cleanup the VIRL simulation execution
230 trap stop_virl_simulation EXIT
231 echo ${VIRL_SID}
232
233 ssh_do ${VIRL_USERNAME}@${VIRL_SERVER} cat /scratch/${VIRL_SID}/topology.yaml
234
235 # Download the topology file from VIRL session
236 scp ${SSH_OPTIONS} \
237     ${VIRL_USERNAME}@${VIRL_SERVER}:/scratch/${VIRL_SID}/topology.yaml \
238     topologies/enabled/topology_VIRL.yaml
239
240 retval=$?
241 if [ ${retval} -ne "0" ]; then
242     echo "Failed to copy topology file from VIRL simulation"
243     exit ${retval}
244 fi
245
246 set +x
247 echo "****************************************************************************************************************************************"
248 echo "3rd step: Start the simulation on the VIRL server                                                                               FINISHED"
249 echo "****************************************************************************************************************************************"
250 set -x
251
252
253 # 4th step: Run functional test suites
254
255 RC=0
256 MORE_FAILS=0
257
258 echo Running functional tests on the VIRL system...
259
260 # There are used three iterations of functional tests there
261 # to check the stability and reliability of the results.
262 partial_logs=""
263 for test_set in 1 2 3
264 do
265     echo
266     echo Functional test loop: ${test_set}
267     echo
268
269     pybot -L TRACE -W 136\
270         -v TOPOLOGY_PATH:${SCRIPT_DIR}/topologies/enabled/topology_VIRL.yaml \
271         --suite "tests.vpp.func" \
272         --include vm_envAND3_node_single_link_topo \
273         --include vm_envAND3_node_double_link_topo \
274         --exclude PERFTEST \
275         --noncritical EXPECTED_FAILING \
276         --output ${LOG_PATH}/output_func_test_set${test_set} \
277         tests/
278     PARTIAL_RC=$(echo $?)
279     partial_logs="${partial_logs} ${LOG_PATH}/output_func_test_set${test_set}.xml"
280     if [ ${PARTIAL_RC} -eq 250 ]; then
281         MORE_FAILS=1
282     fi
283     RC=$((RC+PARTIAL_RC))
284 done
285
286 set +x
287 echo "****************************************************************************************************************************************"
288 echo "4th step: Run functional tests                                                                                                  FINISHED"
289 echo "****************************************************************************************************************************************"
290 set -x
291
292 # Set RETURN_STATUS=1 if some critical test failed
293 if [ ! ${RC} -eq 0 ]; then
294         RETURN_STATUS=1
295 fi
296
297 # Log the final result
298 if [ ${RC} -eq 0 ]; then
299     set +x
300     echo
301     echo "========================================================================================================================================"
302     echo "Final result of all test loops:                                                                                                 | PASS |"
303     echo "All critical tests have passed."
304     echo "========================================================================================================================================"
305     echo
306     set -x
307 elif [ ${MORE_FAILS} -eq 0 ]; then
308     if [ ${RC} -eq 1 ]; then
309         HLP_STR="test has"
310     else
311         HLP_STR="tests have"
312     fi
313     set +x
314     echo
315     echo "========================================================================================================================================"
316     echo "Final result of all test loops:                                                                                                 | FAIL |"
317     echo "${RC} critical ${HLP_STR} failed."
318     echo "========================================================================================================================================"
319     echo
320     set -x
321 else
322     set +x
323     echo
324     echo "========================================================================================================================================"
325     echo "Final result of all test loops:                                                                                                 | FAIL |"
326     echo "More then 250 critical tests have failed in one test loop."
327     echo "========================================================================================================================================"
328     echo
329     set -x
330 fi
331
332 # 7th step: Post-processing test data
333 echo Post-processing test data...
334
335 # Rebot output post-processing
336 rebot --noncritical EXPECTED_FAILING \
337       --output output.xml ${partial_logs}
338
339 # Remove unnecessary files
340 rm -f ${partial_logs}
341
342 # Archive JOB artifacts in jenkins
343 for i in ${JOB_ARCHIVE_ARTIFACTS[@]}; do
344     cp $( readlink -f ${i} | tr '\n' ' ' ) ${JOB_ARCHIVE_DIR}/
345 done
346 # Archive JOB artifacts to logs.fd.io
347 for i in ${LOG_ARCHIVE_ARTIFACTS[@]}; do
348     cp $( readlink -f ${i} | tr '\n' ' ' ) ${LOG_ARCHIVE_DIR}/
349 done
350
351 echo Post-processing finished.
352
353 exit ${RETURN_STATUS}

©2016 FD.io a Linux Foundation Collaborative Project. All Rights Reserved.
Linux Foundation is a registered trademark of The Linux Foundation. Linux is a registered trademark of Linus Torvalds.
Please see our privacy policy and terms of use.